-- TEST program for GET_GUI.E
-- Daniel Berstein, April 1997

-- GET_gui lets you define as many fileds as you want. Once you have
-- defined all, using the READ_FIELD function you make them "active".
-- Using the ESC key, if the field is empty, will exit the "read". If the
-- current field isn't empty, then it's cleared.
-- The current (focus) field is marked by a red frame. The unfocus fields can
-- have a diferent foreground color.
-- To change the current field you may either press ENTER or TAB, but if you're
-- on the last field and press ENTER the "read" is finished. If you use TAB
-- instead you're back to the first field.
-- The order of "reading" the fields is the same as they were declared, using
-- DRAW_FIELD().
-- If you try to type more characters than the ones the fields is declared, a
-- beep will sound to alert you.

--Include files
include get_gui.e

--Declare variables
sequence text
object test

constant grmode = 18
constant screen_bg = 3

constant dark_border = 0
constant light_border = 7

constant focus_fr = 0
constant focus_bg = 15
constant unfocus_fr = 7

--Change to 640x480x16 graphic mode
test = graphics_mode(grmode)

--Make backgroud color
polygon(screen_bg, 1, {{0,0},{0,479},{639,479},{639,0}})

--Define & display field(get) boxes
draw_field(100, 80, 30, dark_border, light_border, focus_fr, focus_bg,unfocus_fr)
draw_field(100, 110, 30, dark_border, light_border, focus_fr, focus_bg,unfocus_fr)
draw_field(100, 160, 4, dark_border, light_border, focus_fr, focus_bg,unfocus_fr)
draw_field(150, 160, 40, dark_border, light_border, focus_fr, focus_bg,unfocus_fr)

--Put labels
putsxy({15,84},"First Name",focus_fr,screen_bg,'a')
putsxy({15,114},"Last Name",focus_fr,screen_bg,'a')
putsxy({108,142},"ZIP",focus_fr,screen_bg,'a')
putsxy({230,142},"Address",focus_fr,screen_bg,'a')


--Define initial contents of boxes
text = {"Daniel","Berstein","","GET_GUI version 1.0 17/April 1997"}

--Read fields
text = read_field(text)

--Show user input
procedure frame(integer col1,integer col2,sequence coord1,sequence coord2)
    draw_line(col1,coord1)
    draw_line(col2,coord2)
end procedure

draw_line(light_border,{{75,335},{75,205},{505,205}})
draw_line(light_border,{{76,334},{76,204},{504,204}})

draw_line(dark_border,{{75,335},{505,335},{505,205}})
draw_line(dark_border,{{76,334},{504,334},{504,204}})

putsxy({220,220},"You've entered:",4,screen_bg,'a')

putsxy({80,250},"FIRST NAME",15,screen_bg,'a')
putsxy({80,270},"LAST NAME",15,screen_bg,'a')
putsxy({80,290},"ZIP",15,screen_bg,'a')
putsxy({80,310},"ADDRESS",15,screen_bg,'a')

putsxy({180,250},text[1],focus_fr,screen_bg,'a')
putsxy({180,270},text[2],focus_fr,screen_bg,'a')
putsxy({180,290},text[3],focus_fr,screen_bg,'a')
putsxy({180,310},text[4],focus_fr,screen_bg,'a')

putsxy({200,380},"Press a key to continue...",focus_fr,screen_bg,'a')

test = wait_key()

--All done, return to text mode and exit
test = graphics_mode(-1)

